!  Map.f90 
! maMapPhysToLinear sample
! Copyright (c) 1999-2003, Zeal SoftStudio
! http://www.zealsoft.com
! support@zealsoft.com
! This sample demonstates how to use maMapPhysToLinear
! function.
!
!  FUNCTIONS:
!   WinMain()      - Entry point for the application;
!                    displays the main window; processes the message loop
!   MapSub()  - Callback routine for the main dialog box
!   MapApply()- Callback routine for the APPLY button
!

!****************************************************************************
!
!  FUNCTION: WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!
!  PURPOSE:  Entry point for the application
!
!  COMMENTS: Displays the main window and processes the message loop
!
!****************************************************************************
include "../memacc.f90"

integer*4 function WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'WinMain' :: WinMain
!DEC$ ENDIF

    use user32
    use kernel32
    use dflogm
    use dfcom
    use dfauto
    use MapGlobals
	use memacc

    implicit none

    integer*4 hInstance
    integer*4 hPrevInstance
    integer*4 lpszCmdLine
    integer*4 nCmdShow

    include 'resource.fd'

    external MapSub
    external MapApply

    ! Variables
    type (T_MSG)            mesg
    integer*4               ret
    logical*4               lret


    ghInstance = hInstance
    ghModule = GetModuleHandle(NULL)
    ghwndMain = NULL
    call COMINITIALIZE(ret)

	! Place your registration information here
	call maLicenseInfo("Your Name", 0)

    lret = DlgInit(IDD_MAP_DIALOG, gdlg)
    if (lret == .FALSE.) goto 99999
    lret = DlgSetSub(gdlg, IDD_MAP_DIALOG, MapSub)
    lret = DlgSetSub(gdlg, IDM_APPLY, MapApply)
    lret = DlgModeless(gdlg, nCmdShow)
    if (lret == .FALSE.) goto 99999

    ! Read and process messsages
    do while( GetMessage (mesg, NULL, 0, 0) ) 
       if ( DlgIsDlgMessage(mesg) .EQV. .FALSE. ) then
           lret = TranslateMessage( mesg )
           ret  = DispatchMessage( mesg )
       end if
    end do
    call DlgUninit(gdlg)
    call COMUNINITIALIZE()

    WinMain = mesg.wParam
    return

99999 &

    ret = MessageBox(ghwndMain, "Error initializing application Map"C, &
                     "Error"C, MB_OK)
    call COMUNINITIALIZE()
    WinMain = 0

end 

!****************************************************************************
!
!  FUNCTION: MapSub ( dlg, id, callbacktype )
!
!  PURPOSE:  Dialog box callback for initialization and destroy
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE MapSub( dlg, id, callbacktype )

  use user32
  use dflogm
  use dfcom
  use dfauto

  implicit none

  type (dialog) dlg
  integer id, callbacktype

  if (callbacktype == dlg_destroy) then
    call PostQuitMessage(0)
  endif

  END SUBROUTINE MapSub

!****************************************************************************
!
!  FUNCTION: MapApply ( dlg, id, callbacktype )
!
!  PURPOSE:  Dialog box callback for APPLY button
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE MapApply( dlg, id, callbacktype )

  use dflogm
  use dfcom
  use dfauto
  use user32
  use kernel32
  use memacc   !To use the MemAccess Library

  implicit none

  include 'resource.fd'
  type (dialog) dlg
  integer id, callbacktype
  character(20) textdate 
  character(100) textstate, text
  integer*4 h, temp
  integer*4 dwAddr
    

  if (callbacktype == dlg_clicked) then
    
    ! Open the library
    if (maOpenLibrary() == .FALSE.) then
        temp = maGetLastState(textstate)
        temp = MessageBox(NULL , textstate, 'Error', MB_ICONSTOP)
        call exit
    endif
    
    ! Map the physical address
    dwAddr = maMapPhysToLinear(Z'FFFF5', 10, h)
    if(dwAddr == 0) then
        temp = maGetLastState(textstate)
        temp = MessageBox(NULL , textstate, 'Error', MB_ICONSTOP)
        call exit
    endif
    
    ! Copy the BIOS date string from the linear address
    call lstrcpyn(textdate, %val(dwAddr), 10)
    write(text, *) "BIOS date:", textdate
	temp = DlgSet( dlg, IDC_STATIC1, text) 

    
    ! Unmap the address
    call maUnmapPhysicalMemory(h, dwAddr)
    
    ! Close the library
    call maCloseLibrary()
  endif

  END SUBROUTINE MapApply


