!  PCI.f90 
!
! PCI Sample
! Copyright (c) 1999-2003, Zeal SoftStudio
! http://www.zealsoftstudio.com
! support@zealsoft.com
! This sample demonstates how to use MemAccess Library to
! get the base address of a PCI device.
!
!  FUNCTIONS:
!   WinMain()      - Entry point for the application;
!                    displays the main window; processes the message loop
!   PCISub()  - Callback routine for the main dialog box
!   PCIApply()- Callback routine for the APPLY button
!

!****************************************************************************
!
!  FUNCTION: WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!
!  PURPOSE:  Entry point for the application
!
!  COMMENTS: Displays the main window and processes the message loop
!
!****************************************************************************
include "../memacc.f90"

integer*4 function WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'WinMain' :: WinMain
!DEC$ ENDIF

    use user32
    use kernel32
    use dflogm
    use PCIGlobals
	use memacc

    implicit none

    integer*4 hInstance
    integer*4 hPrevInstance
    integer*4 lpszCmdLine
    integer*4 nCmdShow

    include 'resource.fd'

    external PCISub
    external PCIApply

    ! Variables
    type (T_MSG)            mesg
    integer*4               ret
    logical*4               lret


    ghInstance = hInstance
    ghModule = GetModuleHandle(NULL)
    ghwndMain = NULL

	! Place your registration information here
	call maLicenseInfo("Your Name", 0)

    lret = DlgInit(IDD_PCI_DIALOG, gdlg)
    if (lret == .FALSE.) goto 99999
	lret = DlgSet(gdlg, IDC_EDIT1, "FFFF")
	lret = DlgSet(gdlg, IDC_EDIT2, "FFFF")
    lret = DlgSetSub(gdlg, IDD_PCI_DIALOG, PCISub)
    lret = DlgSetSub(gdlg, IDM_APPLY, PCIApply)
    lret = DlgModeless(gdlg, nCmdShow)
    if (lret == .FALSE.) goto 99999

    ! Read and process messsages
    do while( GetMessage (mesg, NULL, 0, 0) ) 
       if ( DlgIsDlgMessage(mesg) .EQV. .FALSE. ) then
           lret = TranslateMessage( mesg )
           ret  = DispatchMessage( mesg )
       end if
    end do
    call DlgUninit(gdlg)

    WinMain = mesg.wParam
    return

99999 &

    ret = MessageBox(ghwndMain, "Error initializing application PCI"C, &
                     "Error"C, MB_OK)
    WinMain = 0

end 

!****************************************************************************
!
!  FUNCTION: PCISub ( dlg, id, callbacktype )
!
!  PURPOSE:  Dialog box callback for initialization and destroy
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE PCISub( dlg, id, callbacktype )

  use user32
  use dflogm

  implicit none

  type (dialog) dlg
  integer id, callbacktype

  if (callbacktype == dlg_destroy) then
    call PostQuitMessage(0)
  endif

  END SUBROUTINE PCISub

!****************************************************************************
!
!  FUNCTION: PCIApply ( dlg, id, callbacktype )
!
!  PURPOSE:  Dialog box callback for APPLY button
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE PCIApply( dlg, id, callbacktype )

  use dflogm
  use memacc
  use user32
  use memacctype


  implicit none

  include 'resource.fd'

  type (dialog) dlg
  integer id, callbacktype
  integer*2 deviceid, vendorid, temp, i
  character(10) textvendorid, textdeviceid
  character(100) text, textstate
  character(2000) textAddress
  type(BADDR) baddrBuffer(6)
  integer*4 nResult, nIndex

  if (callbacktype == dlg_clicked) then
    ! Get the physical address
	temp = DlgGet(dlg, IDC_EDIT1, textvendorid)
	temp = DlgGet(dlg, IDC_EDIT2, textdeviceid)
    if (LEN(textvendorid) .GT. 0 .AND. LEN(textdeviceid) .GT. 0) then
		read (textvendorid, 100) vendorid
100     format(Z8)
		read (textdeviceid, 100) deviceid
	else 
        temp = MessageBox(NULL , "Please input the DeviceID and VendorID!", &
					"Error", MB_ICONSTOP)
        call exit
	end if
       
    ! Open the library
    if (maOpenLibrary() == .FALSE.) then
        temp = maGetLastState(textstate)
        temp = MessageBox(NULL , textstate, 'Error', MB_ICONSTOP)
        call exit
    endif
       
    ! Enumerate all devices
    nIndex = 0
    textAddress = ""
loop_1: do
		read (textvendorid, 100) vendorid
		read (textdeviceid, 100) deviceid
        nResult = maGetDeviceBaseAddress(VendorID, &
            DeviceID, nIndex, baddrBuffer(1))
        select case (nResult)
        case (1)
			write(text, 300) vendorid, deviceid
300			format("VendorID: &H", Z4, "  DeviceID: &H", Z4)
            textAddress = trim(textAddress) // trim(text) // Char(13) // Char(10)
            do i = 1, 6
                if (baddrBuffer(i).IOType .NE. 2) then
					write(text, 500) i, baddrBuffer(i).BaseAddress, &
						baddrBuffer(i).BaseAddress + baddrBuffer(i).Size - 1
500					format("   Address(", Z1, "): ", Z8, "-", Z8, &
							"      ")
					if (baddrBuffer(i).IOType == 1) then
						text = trim(text) // " Port I/O"
					else
						text = trim(text) // " Memory I/O"
					endif
                    textAddress = trim(textAddress) // trim(text) // Char(13) // Char(10)
                end If
            end do
            textAddress = trim(textAddress) // char(13) // char(10)
        case (0)
	        temp = maGetLastState(textstate)
            textAddress = "Error :" // textstate
        case (-1)
            if (LEN(textAddress) == 0) then
                textAddress = "No device found."
            end if
        end select
        nIndex = nIndex + 1
		if (nResult .NE. 1) exit loop_1
    end do loop_1
    
	temp = DlgSet(dlg, IDC_EDIT3, textAddress)

	! Close the library
    call maCloseLibrary()
  endif

  END SUBROUTINE PCIApply


