! MemAccess Library interface 
! Copyright (c) 1997-2003 Zeal SoftStudio.
! E-Mail: support@zealsoft.com
! Web: http://www.zealsoft.com

!DEC$ FREEFORM
!DEC$ IF .NOT. DEFINED(__memacc_INCLUDE)
module memacctype

type BADDR
	sequence
	integer*4 BaseAddress;
	integer*4 Size;
	integer*4 IOType;
end type BADDR

end module memacctype

MODULE memacc

!DEC$ ENDIF

!**** Define constant symbol ***
integer :: ERROR_MA_DRIVER = 2
integer :: ERROR_MA_SCM_CANT_CONNECT = 9998

interface

! Open the diver.
logical function maOpenLibrary()
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maOpenLibrary@0' :: maOpenLibrary
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maOpenLibrary' :: maOpenLibrary
!DEC$ ENDIF
end function

! Close the driver.
logical function maCloseLibrary()
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maCloseLibrary@0' :: maCloseLibrary
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maCloseLibrary' :: maCloseLibrary
!DEC$ ENDIF
end function

!****************Read functions***************************
! Return a byte word at memory location nAddress.
integer(1) function maPeekB(nAddress)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maPeekB@4' :: maPeekB
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maPeekB' :: maPeekB
!DEC$ ENDIF
integer(4) nAddress
end function

! Return a word at memory location nAddress.
integer(2) function maPeekW(nAddress)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maPeekW@4' :: maPeekW
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maPeekW' :: maPeekW
!DEC$ ENDIF
integer(4) nAddress
end function

! Return a double word at memory location nAddress.
integer(4) function maPeekD(PortNum)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maPeekD@4' :: maPeekD
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maPeekD' :: maPeekD
!DEC$ ENDIF
integer(4) nAddress
end function

!****************** End of read functions*******************


!******************* Write functions************************
! Store a byte at memory location nAddress.
logical function maPokeB(nAddress, nData)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maPokeB@8' :: maPokeB
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maPokeB' :: maPokeB
!DEC$ ENDIF
integer(4) nAddress, nData
end function

! Store a word at memory location nAddress.
logical function maPokeW(nAddress, nData)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maPokeW@8' :: maPokeW
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maPokeW' :: maPokeW
!DEC$ ENDIF
integer(4) nAddress, nData
end function

! Store a double word at memory location nAddress.
logical function maPokeD(nAddress, nData)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maPokeD@8' :: maPokeD
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maPokeD' :: maPokeD
!DEC$ ENDIF
integer(4) nAddress, nData
end function

!******************* End of write functions*******************


! Install the service under Windows NT/2000/XP
logical function maInstallService()
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maInstallService@0' :: maInstallService
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maInstallService' :: maInstallService
!DEC$ ENDIF
end function

! Remove the service under Windows NT/2000/XP
logical function maRemoveService()
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maRemoveService@0' :: maRemoveService
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maRemoveService' :: maRemoveService
!DEC$ ENDIF
end function

! Map the physical address to process address
integer(4) function maMapPhysToLinear(PhsAddr, dwSize, hMem)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maMapPhysToLinear@12' :: maMapPhysToLinear
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maMapPhysToLinear' :: maMapPhysToLinear
!DEC$ ENDIF
!DEC$ ATTRIBUTES REFERENCE :: hMem
integer(4) PhsAddr, dwSize
integer(4) hMem
end function

! Unmap the address
logical function maUnmapPhysicalMemory(hMem, LinearAddr)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maUnmapPhysicalMemory@8' :: maUnmapPhysicalMemory
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maUnmapPhysicalMemory' :: maUnmapPhysicalMemory
!DEC$ ENDIF
integer(4) hMem, LinearAddr
end function

! Get the base address of a PCI device
integer*4 function maGetDeviceBaseAddress(VendorID, DeviceID, nIndex, baddrBuffer)

use memacctype

!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maGetDeviceBaseAddress@16' :: maGetDeviceBaseAddress
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maGetDeviceBaseAddress' :: maGetDeviceBaseAddress
!DEC$ ENDIF
!DEC$ ATTRIBUTES REFERENCE :: VendorID, DeviceID, baddrBuffer
integer*2 VendorID, DeviceID
integer*4 nIndex
type(BADDR) :: baddrBuffer
end function

!Set the registration information.
subroutine maLicenseInfo(sUserName, sKey)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maLicenseInfo@8' :: maLicenseInfo
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maLicenseInfo' :: maLicenseInfo
!DEC$ ENDIF
!DEC$ ATTRIBUTES REFERENCE :: sUserName
character *(*) sUserName
integer(4)  sKey
end subroutine

!Returns a value indicates whether the application is running under Windows NT/2000 system.
logical function maIsWinNT()
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maIsWinNT@0' :: maIsWinNT
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maIsWinNT' :: maIsWinNT
!DEC$ ENDIF
end function

!Returns the version of MemAccess Library.
integer function maGetVersion()
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maGetVersion@0' :: maGetVersion
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maGetVersion' :: maGetVersion
!DEC$ ENDIF
end function

!Returns a value indicating the last operation is successful or not.
integer function maGetLastState(s)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_maGetLastState@4' :: maGetLastState
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'maGetLastState' :: maGetLastState
!DEC$ ENDIF
!DEC$ ATTRIBUTES REFERENCE :: s
character *(*) s

end function

! Convert V86 address to 32-bit physical address.
!integer function V86_To_PhyAddress(seg,ofs)

!	integer*4 seg, ofs
!end function
			   
end interface

CONTAINS

! Convert V86 address to 32-bit physical address.
integer function V86_To_PhyAddress(seg,ofs)
	integer*4 seg, ofs
	V86_To_PhyAddress = ior(isha(seg, 4), ofs)
end function

!DEC$ IF .NOT. DEFINED(__memacc_INCLUDE)
END MODULE memacc
!DEC$ ENDIF

